require 'manband/flowconfig.rb'
require 'amqp'

# Utility classes
class Utils


  @@connection = nil
  @@channel    = nil
  @@exchange = nil

  def self.setcontext()
    if(@@connection==nil)
      @@connection = AMQP.connect(FlowConfig.config())
      @@channel    = AMQP::Channel.new(@@connection)
      @@exchange = @@channel.direct()
    end
  end

  # Send a message in context
  # args:
  # dest name of destination queue
  # msg  message to send. Message is a hash with keys operation and msg.
  def self.enqueue(dest,data= {})
    Utils.setcontext()
    msg = data.to_json
    queue = @@channel.queue(dest, :auto_delete => false, :durable => true)
    queue.bind(@@exchange)
    #@@exchange.publish(msg, :routing_key => dest)
    @@channel.direct("").publish(msg, :routing_key => dest)
  end

  # Creates a context and sends a message
  # args:
  # dest name of destination queue
  # msg  message to send. Message is a hash with keys operation and msg.
  def self.publish(dest,data= {})
  msg = data.to_json
  EventMachine.run do
    connection = AMQP.connect(FlowConfig.config())
    channel    = AMQP::Channel.new(connection)
    #exchange = channel.direct()   
    #queue = channel.queue(dest, :auto_delete => false, :durable => true)
    #queue.bind(exchange)
    #exchange.publish(msg, :routing_key => dest) do
    channel.direct("").publish(msg, :routing_key => dest) do
    connection.close { EventMachine.stop }
    end
  end
  end

end
